Differences between revisions 5 and 6
Revision 5 as of 2014-07-17 10:41:49
Size: 7553
Editor: ?Bastif
Comment: Add possibility to choose UI (for example console or telnet) and configuration of webui plugin for swing UI access
Revision 6 as of 2019-08-15 20:26:24
Size: 7614
Editor: nodiscc
Comment: add CategoryNetwork CategorySoftware
Deletions are marked like this. Additions are marked like this.
Line 235: Line 235:

---------------------

CategoryNetwork CategorySoftware

How to run Azureus as a daemon (for wheezy)

This HOWTO will explain you how to run Azureus/Vuze as a daemon. You can choose to use either "--ui=console" or "--ui=telnet" parameter of Azureus

NB : You need root permissions for almost all commands

Init Script

Copy/Paste this script file in /etc/init.d/azureus-daemon

#!/bin/sh
### BEGIN INIT INFO
# Provides:          azureus-daemon
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Should-Start:      $network
# Should-Stop:       $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Daemonized version of azureus
# Description:       Starts Azureus in console UI with the user specified in
#                    /etc/default/azureus
### END INIT INFO


# Author & Source: https://wiki.debian.org/AzureusAsDaemon

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Azureus as a deamon"
NAME=azureus
DAEMON=/usr/bin/$NAME
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
DAEMON_ARGS="--ui=$AZUREUS_UI"

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon -b -c $AZUREUS_USER --start --quiet -m --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
                || return 1
        start-stop-daemon -b -c $AZUREUS_USER --start --quiet -m --pidfile $PIDFILE --exec $DAEMON -- \
                $DAEMON_ARGS \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{

        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon -m -c $AZUREUS_USER --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name java
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon -c $AZUREUS_USER --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon -b -c $AZUREUS_USER --stop --signal 1 --quiet -m --pidfile $PIDFILE --name $NAME
        return 0
}

case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
  #reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME"
        #do_reload
        #log_end_msg $?
        #;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac

:

Configuration file

Create file /etc/default/azureus and set the username to use to run azureus as a daemon

AZUREUS_USER="username"

# SET UI to console or telnet
# If telnet, you can connect to the default azureus telnet port : 57006
# Ref: http://svn.vuze.com/public/client/trunk/uis/src/org/gudy/azureus2/ui/telnet/UI.java
# If it doesn't work check the value of Telnet_iPort in  ~/azureus.config
# You have to connect by telnet with "telnet 127.0.0.1 57006" Otherwise set the parameter of allowed hosts as defined here
# http://wiki.vuze.com/w/TelnetUI
AZUREUS_UI="telnet"

Set the right permissions

Execute as root:

chown root:root /etc/init.d/azureus-daemon
chmod 755 /etc/init.d/azureus-daemon

chown root:root /etc/default/azureus
chmod 644 /etc/default/azureus

Execute as root:

update-rc.d azureus-daemon defaults

Manually Start the daemon

Execute as root:

/etc/init.d/azureus-daemon start

Control Azureus from swing UI using the webui

If you are running azureus 4.3.0.6 from wheezy, you have to get webui plugin version 1.7.0 from here http://plugins.vuze.com/plugins/webui_1.7.0.zip (homepage : http://plugins.vuze.com/plugin_details.php?plugin=webui )

So that the WebUI has access to the content of the clipboard append this to your '''$HOME/.java.policy'''

grant codeBase "http://localhost:6883/*" {
permission java.awt.AWTPermission "accessClipboard";
};

Reminders

  • The configuration of azureus ( ~/.azureus ) used is the one of the user set in /etc/default/azureus
  • You won't be able to execute azureus a second time as this user (at least I didn't find the way to do it)

References

Method inspired by http://wiki.vuze.com/w/Daemonized_Azureus


CategoryNetwork CategorySoftware